/****************************************************************
	LLPAM Emulator
	Dispatch Code
	#included into llpam.c
	generates different code depending on
	TRACECODE and RMODECODE

	Last modified by Mutsunori Banbara on Jaly 27, 2000
	(banbara@cs32.scitec.kobe-u.ac.jp)
****************************************************************/
switch (OP) {
 case HALT:
     am_halt(); break;
 case FAIL:
     AM_FAIL; break;
 case TRACE:
     am_trace(); break;
 case NOP:
     am_nop(); break;
 case DEREF_A:
     am_deref_a(); break;
 case DEREF_Y:
     am_deref_y(); break;
 case BUILTIN1:
     am_builtin(); break;
 case BUILTIN2:
     am_builtin(); break;
 case DEBUG_DMP_A:
     am_debug_dmp_a(); break;
 case DEBUG_DMP_Y:
     am_debug_dmp_y(); break;
 case DEBUG_PRN_A:
     am_debug_prn_a(); break;
 case DEBUG_PRN_Y:
     am_debug_prn_y(); break;
 case DEBUG_DMP_E:
     am_debug_dmp_e(); break;
 case DEBUG_DMP_B:
     am_debug_dmp_b(); break;
 case DEBUG_DMP_S:
     am_debug_dmp_s(); break;
 case DEBUG_DMP_R:
     am_debug_dmp_r(); break;
 case PUT_VAR_A:
     am_put_var_a(); break;
 case PUT_VAR_Y:
     am_put_var_y(); break;
 case PUT_VAL_A:
     am_put_val_a(); break;
 case PUT_VAL_Y:
     am_put_val_y(); break;
 case PUT_UNSAFE_VAL:
     am_put_unsafe_val(); break;
 case PUT_STR:
     am_put_str(); break;
 case PUT_LIST:
     am_put_list(); break;
 case PUT_CON:
     am_put_con(); break;
 case PUT_INT:
     am_put_int(); break;
 case PUT_GROUND:
     am_put_ground(); break;
 case GET_VAR_A:
     am_get_var_a(); break;
 case GET_VAR_Y:
     am_get_var_y(); break;
 case GET_VAL_A:
     am_get_val_a(); break;
 case GET_VAL_Y:
     am_get_val_y(); break;
 case GET_STR:
     am_get_str();
#ifdef RMODECODE
     if (!readmode) goto WRITEMODE; break;
#else
     if ( readmode) goto READMODE;  break;
#endif
 case GET_LIST:
     am_get_list();
#ifdef RMODECODE
     if (!readmode) goto WRITEMODE; break;
#else
     if ( readmode) goto READMODE;  break;
#endif
 case GET_CON:
     am_get_con(); break;
 case GET_INT:
     am_get_int(); break;
 case GET_GROUND:
     am_get_ground(); break;
 case SET_VAR_A:
     am_set_var_a(); break;
 case SET_VAR_Y:
     am_set_var_y(); break;
 case SET_VAL_A:
     am_set_val_a(); break;
 case SET_VAL_Y:
     am_set_val_y(); break;
 case SET_LOCAL_VAL_A:
     am_set_local_val_a(); break;
 case SET_LOCAL_VAL_Y:
     am_set_local_val_y(); break;
 case SET_CON:
     am_set_con(); break;
 case SET_INT:
     am_set_int(); break;
 case SET_GROUND:
     am_set_ground(); break;
 case SET_VOID:
     am_set_void(); break;
 case UNIFY_VAR_A:
#ifdef RMODECODE
     am_unify_var_a_r(); break;
#else
     am_unify_var_a_w(); break;
#endif
 case UNIFY_VAR_Y:
#ifdef RMODECODE
     am_unify_var_y_r(); break;
#else
     am_unify_var_y_w(); break;
#endif
 case UNIFY_VAL_A:
#ifdef RMODECODE
     am_unify_val_a_r(); break;
#else
     am_unify_val_a_w(); break;
#endif
 case UNIFY_VAL_Y:
#ifdef RMODECODE
     am_unify_val_y_r(); break;
#else
     am_unify_val_y_w(); break;
#endif
 case UNIFY_LOCAL_VAL_A:
#ifdef RMODECODE
     am_unify_local_val_a_r(); break;
#else
     am_unify_local_val_a_w(); break;
#endif
 case UNIFY_LOCAL_VAL_Y:
#ifdef RMODECODE
     am_unify_local_val_y_r(); break;
#else
     am_unify_local_val_y_w(); break;
#endif
 case UNIFY_CON:
#ifdef RMODECODE
     am_unify_con_r(); break;
#else
     am_unify_con_w(); break;
#endif
 case UNIFY_INT:
#ifdef RMODECODE
     am_unify_int_r(); break;
#else
     am_unify_int_w(); break;
#endif
 case UNIFY_GROUND:
#ifdef RMODECODE
     am_unify_ground_r(); break;
#else
     am_unify_ground_w(); break;
#endif
 case UNIFY_VOID:
#ifdef RMODECODE
     am_unify_void_r(); break;
#else
     am_unify_void_w(); break;
#endif
 case ALLOCATE:
     am_allocate(); break;
 case DEALLOCATE:
     am_deallocate(); break;
 case CALL:
#ifdef TRACECODE
     am_call_trace(); break;
#else
     am_call(); break;
#endif
 case EXECUTE:
#ifdef TRACECODE
     am_execute_trace(); break;
#else
     am_execute(); break;
#endif
 case EXECUTE_INDIRECT:
#ifdef TRACECODE
     am_execute_indirect_trace(); break;
#else
     am_execute_indirect();  break;
#endif
 case EXECUTE_INDIRECT_NOTRACE:
     am_execute_indirect_notrace(); break;
 case EXECUTE_PROG_INDIRECT:
     am_execute_prog_indirect(); break;
 case PROCEED:
     am_proceed(); break;
 case TRY_ME_ELSE:
     am_try_me_else(); break;
 case RETRY_ME_ELSE:
     am_retry_me_else(); break;
 case TRUST_ME:
     am_trust_me(); break;
 case TRY:
     am_try(); break;
 case RETRY:
     am_retry(); break;
 case TRUST:
     am_trust(); break;
 case SWITCH_ON_TERM:
     am_switch_on_term(); break;
 case SWITCH_ON_CON:
     am_undefined(); break;
 case SWITCH_ON_STR:
     am_undefined(); break;
 case NECK_CUT:
     am_neck_cut(); break;
 case GET_LEVEL:
     am_get_level(); break;
 case CUT:
     am_cut(); break;
 case BEGIN_IMP_A:
     am_begin_imp_a(); break;
 case BEGIN_IMP_Y:
     am_begin_imp_y(); break;
 case BEGIN_EXP_IMP_A:
     am_begin_exp_imp_a(); break;
 case BEGIN_EXP_IMP_Y:
     am_begin_exp_imp_y(); break;
 case ADD_RES:
     am_add_res(); break;
 case ADD_EXP_RES:
     am_add_exp_res(); break;
 case MID_IMP_A:
     am_mid_imp_a(); break;
 case MID_IMP_Y:
     am_mid_imp_y(); break;
 case MID_EXP_IMP_A:
     am_mid_exp_imp_a(); break;
 case MID_EXP_IMP_Y:
     am_mid_exp_imp_y(); break;
 case END_IMP_A:
     am_end_imp_a(); break;
 case END_IMP_Y:
     am_end_imp_y(); break;
 case END_EXP_IMP_A:
     am_end_exp_imp_a(); break;
 case END_EXP_IMP_Y:
     am_end_exp_imp_y(); break;
 case MORE_IMP:
     am_more_imp(); break;
 case BEGIN_WITH_A:
     am_begin_with_a(); break;
 case BEGIN_WITH_Y:
     am_begin_with_y(); break;
 case MID_WITH_A:
     am_mid_with_a(); break;
 case MID_WITH_Y:
     am_mid_with_y(); break;
 case END_WITH_A:
     am_end_with_a(); break;
 case END_WITH_Y:
     am_end_with_y(); break;
 case BEGIN_BANG_A:
     am_begin_bang_a(); break;
 case BEGIN_BANG_Y:
     am_begin_bang_y(); break;
 case END_BANG_A:
     am_end_bang_a(); break;
 case END_BANG_Y:
     am_end_bang_y(); break;
 case UNIFY_RESOURCE:
     am_unify_resource(); break;
 case RESOURCE_BODY:
     am_resource_body(); break;
 case TOP:
     am_top(); break;
 case ERASE:
     am_erase(); break;
 case DEBUG_DMP_R_REG:
     am_debug_dmp_r_reg(); break;
 case PUT_CLO:
     am_put_closure();
#ifdef RMODECODE
     if (!readmode) goto WRITEMODE; break;
#else
     if ( readmode) goto READMODE;  break;
#endif
 case EXECUTE_CLO:
     am_execute_closure();
#ifdef RMODECODE
     if (!readmode) goto WRITEMODE; break;
#else
     if ( readmode) goto READMODE;  break;
#endif
 case PICKUP_RES:
     am_pickup_resource(); break;
 case CONSUME:
     am_consume(); break;
 case RESTORE_RES:
     am_restore_resource(); break;
 case TRY_RES:
     am_try_resource(); break;
 case RETRY_RES_ELSE:
     am_retry_resource_else(); break;
 case TRUST_RES:
     am_trust_resource(); break;
 case IF_NO_RES:
     am_if_no_resource(); break;
 case ADD_RES_TERM:
     am_add_res_term(); break;
 case ADD_EXP_RES_TERM:
     am_add_exp_res_term(); break;
 case PICKUP_RES_TERM:
     am_pickup_resource_term(); break;
 case EXECUTE_RES_INDIRECT:
     am_execute_resource_indirect(); break;
 default:
     am_undefined(); break;
}
