/****************************************************************
	LLPAM Emulator
        (system dependent routines)
	by Naoyuki Tamura (tamura@kobe-u.ac.jp)
	   Dept. CS, Kobe University
****************************************************************/
#define	EXTERN extern
#include "llpam.h"

#ifdef NEXT

#include <sys/time.h>
#include <sys/resource.h>

long usertime()
{
  struct rusage rusage;

  getrusage(RUSAGE_SELF,&rusage);
  return 1000L * rusage.ru_utime.tv_sec + rusage.ru_utime.tv_usec/1000L;
}

#else

#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>

long usertime()
{
    struct tms buffer;

    times(&buffer);
    return (1000L * buffer.tms_utime)/(long)HZ;
}

#endif
