/****************************************************************
  Prolog-java interface
	by Naoyuki Tamura (tamura@kobe-u.ac.jp)
	   Dept. CS, Kobe University
****************************************************************/
import java.awt.*;

public abstract class PrologFrame extends Frame implements Runnable {
    PrologControlPanel control = null;
    Thread frameThread = null;

    public PrologFrame() {
	frameThread = new Thread(this);
	frameThread.start();
    }

    void sendArgument() {
    }

    void receiveResult() {
    }

    void aborted() {
    }

    void quit() {
	System.exit(0);
    }

    public void run() {
	try {
	    Thread.sleep(500);
	} catch (InterruptedException e) {}
	show();
	while (Thread.currentThread() == frameThread) {
	    repaint();
	    try {
		Thread.sleep(500);
	    } catch (InterruptedException e) {}
	    int state = control.getState();
	    if (state == control.WAIT_S) {
		sendArgument();
	    } else if (state == control.WAIT_R) {
		receiveResult();
	    } else if (state == control.ABORT) {
		aborted();
	    } else if (state == control.QUIT) {
		break;
	    }
	}
	control.close();
	quit();
    }
}


